/// <reference types="@types/codemirror" />
export import CodeMirror = require('codemirror');
import { CodeMirrorAdapter, ILspConnection, ITextEditorOptions } from 'lsp-editor-adapter';
import * as lsProtocol from 'vscode-languageserver-protocol';
import { FreeTooltip } from '../free_tooltip';
export declare class CodeMirrorAdapterExtension extends CodeMirrorAdapter {
    private marked_diagnostics;
    protected create_tooltip: (markup: lsProtocol.MarkupContent, cm_editor: CodeMirror.Editor, position: CodeMirror.Position) => FreeTooltip;
    private _tooltip;
    private show_next_tooltip;
    private last_hover_response;
    private last_hover_character;
    invoke_completer: Function;
    constructor(connection: ILspConnection, options: ITextEditorOptions, editor: CodeMirror.Editor, create_tooltip: (markup: lsProtocol.MarkupContent, cm_editor: CodeMirror.Editor, position: CodeMirror.Position) => FreeTooltip, invoke_completer: Function);
    readonly hover_character: CodeMirror.Position;
    handleGoTo(locations: any): void;
    handleCompletion(completions: lsProtocol.CompletionItem[]): void;
    protected static get_markup_for_hover(response: lsProtocol.Hover): lsProtocol.MarkupContent;
    protected remove_tooltip(): void;
    handleHover(response: lsProtocol.Hover): void;
    get_cm_editor(position: CodeMirror.Position): CodeMirror.Editor;
    get_language_at(position: CodeMirror.Position, editor?: CodeMirror.Editor): any;
    protected get_markup_for_signature_help(response: lsProtocol.SignatureHelp, language: string): lsProtocol.MarkupContent;
    handleSignature(response: lsProtocol.SignatureHelp): void;
    handleChange(cm: CodeMirror.Editor, change: CodeMirror.EditorChange): void;
    protected highlight_range(range: lsProtocol.Range, class_name: string): void;
    handleMouseOver(event: MouseEvent): void;
    readonly transform: (position: CodeMirror.Position) => CodeMirror.Position;
    get_editor_index(position: CodeMirror.Position): number;
    readonly get_cell_id: (position: CodeMirror.Position) => string;
    handleDiagnostic(response: lsProtocol.PublishDiagnosticsParams): void;
}
