"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jupyterlab_1 = require("./jupyterlab");
const completion_1 = require("../completion");
class FileEditorAdapter extends jupyterlab_1.JupyterLabWidgetAdapter {
    get document_path() {
        return this.widget.context.path;
    }
    get language() {
        return this.jumper.language;
    }
    get_document_content() {
        return this.cm_editor.getValue();
    }
    get ce_editor() {
        return this.editor.editor;
    }
    get cm_editor() {
        return this.ce_editor.editor;
    }
    find_ce_editor(cm_editor) {
        return this.editor.editor;
    }
    constructor(editor_widget, jumper, app, completion_manager, rendermime_registry) {
        super(app, rendermime_registry, 'completer:invoke-file');
        this.jumper = jumper;
        this.widget = editor_widget;
        this.editor = editor_widget.content;
        this.connect().then();
        this.create_adapter();
        const connector = new completion_1.LSPConnector({
            editor: this.editor.editor,
            connection: this.connection,
            coordinates_transform: null
        });
        completion_manager.register({
            connector,
            editor: this.editor.editor,
            parent: editor_widget
        });
    }
    get path() {
        return this.widget.context.path;
    }
}
exports.FileEditorAdapter = FileEditorAdapter;
