/// <reference types="@types/codemirror" />
import { IPosition, LspWsConnection } from 'lsp-editor-adapter';
import { CodeMirror, CodeMirrorAdapterExtension } from './codemirror';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { CodeJumper } from '@krassowski/jupyterlab_go_to_definition/lib/jumpers/jumper';
import { CodeEditor } from '@jupyterlab/codeeditor';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import * as lsProtocol from 'vscode-languageserver-protocol';
import { FreeTooltip } from '../free_tooltip';
import { IDocumentWidget } from '@jupyterlab/docregistry';
export declare abstract class JupyterLabWidgetAdapter {
    app: JupyterFrontEnd;
    connection: LspWsConnection;
    jumper: CodeJumper;
    adapter: CodeMirrorAdapterExtension;
    rendermime_registry: IRenderMimeRegistry;
    widget: IDocumentWidget;
    private invoke_command;
    protected constructor(app: JupyterFrontEnd, rendermime_registry: IRenderMimeRegistry, invoke: string);
    abstract readonly document_path: string;
    abstract readonly language: string;
    readonly root_path: string;
    abstract get_document_content(): string;
    abstract readonly cm_editor: CodeMirror.Editor;
    abstract find_ce_editor(cm_editor: CodeMirror.Editor): CodeEditor.IEditor;
    invoke_completer(): Promise<any>;
    connect(): Promise<void>;
    handle_jump(locations: lsProtocol.Location[]): void;
    create_adapter(): void;
    get_doc_position_from_context_menu(): IPosition;
    protected create_tooltip(markup: lsProtocol.MarkupContent, cm_editor: CodeMirror.Editor, position: CodeMirror.Position): FreeTooltip;
}
