import { JupyterLabWidgetAdapter } from './jupyterlab';
import { Notebook, NotebookPanel } from '@jupyterlab/notebook';
import { CodeMirror } from './codemirror';
import { NotebookAsSingleEditor } from '../notebook_mapper';
import { ICompletionManager } from '@jupyterlab/completer';
import { NotebookJumper } from '@krassowski/jupyterlab_go_to_definition/lib/jumpers/notebook';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { CodeEditor } from '@jupyterlab/codeeditor';
export declare class NotebookAdapter extends JupyterLabWidgetAdapter {
    editor: Notebook;
    widget: NotebookPanel;
    notebook_as_editor: NotebookAsSingleEditor;
    completion_manager: ICompletionManager;
    jumper: NotebookJumper;
    constructor(editor_widget: NotebookPanel, jumper: NotebookJumper, app: JupyterFrontEnd, completion_manager: ICompletionManager, rendermime_registry: IRenderMimeRegistry);
    is_ready(): boolean;
    readonly document_path: string;
    readonly language: string;
    find_ce_editor(cm_editor: CodeMirror.Editor): CodeEditor.IEditor;
    init_once_ready(): Promise<void>;
    get_notebook_content(): string;
    readonly cm_editor: NotebookAsSingleEditor;
    get_document_content(): string;
    refresh_lsp_notebook_image(slot: any): void;
}
