"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function sleep(timeout) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise(resolve => {
            setTimeout(() => {
                resolve();
            }, timeout);
        });
    });
}
exports.sleep = sleep;
// TODO: there is a JL native version of this which uses adaptive rate, maybe use instead?
function until_ready(is_ready, max_retrials = 35, interval = 50, verbose = false) {
    return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
        let i = 0;
        while (is_ready() !== true) {
            i += 1;
            if (max_retrials != -1 && i > max_retrials) {
                reject('Too many retrials');
                break;
            }
            if (verbose) {
                console.log('waiting');
            }
            yield sleep(interval);
        }
        resolve(is_ready);
    }));
}
exports.until_ready = until_ready;
/**
 * TODO: this is slightly modified copy paste from jupyterlab-go-to-definition/editors/codemirror/extension.ts;
 */
function getModifierState(event, modifierKey) {
    // Note: Safari does not support getModifierState on MouseEvent, see:
    // https://github.com/krassowski/jupyterlab-go-to-definition/issues/3
    // thus AltGraph and others are not supported on Safari
    // Full list of modifier keys and mappings to physical keys on different OSes:
    // https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/getModifierState
    if (event.getModifierState !== undefined) {
        return event.getModifierState(modifierKey);
    }
    switch (modifierKey) {
        case 'Shift':
            return event.shiftKey;
        case 'Alt':
            return event.altKey;
        case 'Control':
            return event.ctrlKey;
        case 'Meta':
            return event.metaKey;
        default:
            console.warn(`State of the modifier key "${modifierKey}" could not be determined.`);
    }
}
exports.getModifierState = getModifierState;
